/** 
 * Function link to jQurey tree new features
 * 
 * @author nils
 * @date 2012/09/06
 * @since Xper 2.3
 *
 */
//----------------------------------------------------------------------------------------
// I - load tree
jQuery(document).ready(function(){
	try {
		jQuery(".filetree").treeview({
			toggle: function() {}
		});
	} catch (e) {
		// no tree in page
	}
});
//----------------------------------------------------------------------------------------
// II - hide / show scopes
//var isShow = true;
hideShowClass=function(elemt, show, hide, className){
	var allScopes  = document.getElementsByClassName(className);
	if (elemt.value == hide) {
		elemt.value = show;
		for (var i = 0; i < allScopes.length; i++) {
			allScopes[i].style.display = 'none';
		}
		//isShow = false;
	} else {
		elemt.value = hide;
		for (var i = 0; i < allScopes.length; i++) {
			allScopes[i].style.display = '';
		}
		//isShow = true;
	}
}//hideShowClass
//----------------------------------------------------------------------------------------
// III - functions present in decent browser
if (!document.getElementsByClassName) {
	document.getElementsByClassName = function getElementsByClassName(className, tag, elm) {
		var testClass = new RegExp("(^|\\s)" + className + "(\\s|jQuery)");
		var tag = tag || "*";
		var elm = elm || document;
		var elements = (tag == "*" && elm.all)? elm.all : elm.getElementsByTagName(tag);
		var returnElements = [];
		var current;
		var length = elements.length;
		for(var i=0; i<length; i++){
			current = elements[i];
			if(testClass.test(current.className)){ returnElements.push(current); }
		}
		return returnElements;
	} // function getElementsByClassName(className, tag, elm)
} // fi (!document.getElementsByClassName)
//----------------------------------------------------------------------------------------
// IV- filter elements in tree
jQuery(document).ready(function() {  
	zebraRows('tbody tr:odd td', 'odd');  
	// IV.A - filter on search
	jQuery('#filter1').keyup(function(event) { 
		//if esc is pressed or nothing is entered  
		if (event.keyCode == 27 || jQuery(this).val() == '') {  
			jQuery(this).val(''); 
			//we want each row to be visible because if nothing is entered then all rows are matched.
			jQuery('tbody tr').removeClass('visible').show().addClass('visible'); 
			jQuery('ul li').removeClass('visible').show().addClass('visible');  
		} else { 
			// filter 
			filter('tbody tr', jQuery(this).val());  
			filter('ul li', jQuery(this).val());  
			//filter('ul li ul li', jQuery(this).val()); 
			//filter('ul li ul li ul li', jQuery(this).val());
			//filter('ul li ul li ul li', jQuery(this).val());  
		}  
		//reapply zebra rows  
		jQuery('.visible td').removeClass('odd');  
		jQuery('.visible ul').removeClass('odd');  
		zebraRows('.visible:odd td', 'odd'); 
		zebraRows('.visible:odd li', 'odd'); 
	}); 
	/*
	// IV.B - filter on filters
	jQuery('#filterScope').keyup(function(event) { 
		//if esc is pressed or nothing is entered  
		if (event.keyCode == 27 || jQuery(this).val() == '') {  
			jQuery(this).val(''); 
			//we want each row to be visible because if nothing is entered then all rows are matched.
			//jQuery('tbody tr').removeClass('visible').show().addClass('visible'); 
			jQuery('ul li').removeClass('visible').show().addClass('visible');  
		} else { 
			// filter 
			//filter('tbody tr', jQuery(this).val());  
			filterScope('ul li', jQuery(this).val());  
			//filter('ul li ul li', jQuery(this).val()); 
			//filter('ul li ul li ul li', jQuery(this).val());
			//filter('ul li ul li ul li', jQuery(this).val());  
		}  
		//reapply zebra rows  
		jQuery('.visible td').removeClass('odd');  
		jQuery('.visible ul').removeClass('odd');  
		zebraRows('.visible:odd td', 'odd'); 
	}); 
	*/
});
// IV.B - filter on scopes
jQuery(document).ready(function() { 
	var param_GET = getUrlGETParams();
	if (typeof param_GET.scopeFilter != 'undefined' && param_GET['scopeFilter']!='') {
		setTimeout("filterScope('ul li', '"+param_GET['scopeFilter']+"')",50);
		//document.getElementById('hideShowListScopeButton').value = 'Hide list of scopes';
		hideShowClass(document.getElementById('hideShowListScopeButton'),'Show list of scopes','Hide list of scopes','listScope');
		//hideShowClass(document.getElementById('resetFilter'),'Show list of scopes','Hide list of scopes','listScope');
	}
});
// IV.C - filter: globales functions  
//used to apply alternating row styles  
zebraRows = function(selector, className) {  
	jQuery(selector).removeClass(className).addClass(className); 
	//alert(0); 
} 
filter = function(selector, query) { 
	query = jQuery.trim(query); //trim white space  
	query = query.replace(/ /gi, '|'); //add OR for regex query  
	jQuery(selector).each(function() {  
		(jQuery(this).text().search(new RegExp(query, "i")) < 0) ? jQuery(this).hide().removeClass('visible') : jQuery(this).show().addClass('visible');  
	});  
} 
filterScope = function(selector, query) { 
	// query = jQuery.trim(query); //trim white space  
	// query = query.replace(/ /gi, '&'); //add AND for regex query  
	jQuery(selector).each(function() {  
		(jQuery(this).html().search(new RegExp(query, "i")) < 0) ? jQuery(this).hide().removeClass('visible') : jQuery(this).show().addClass('visible');  
	}); 
	if (query!='') {
		document.getElementById('allScopes').style.display = '';
	} else {
		document.getElementById('allScopes').style.display = 'none';
	}
	jQuery('.visible ul').removeClass('odd');  
	zebraRows('.visible:odd li', 'odd');  
}
jQuery('tbody tr').addClass('visible');
jQuery('ul li').addClass('visible');
getUrlGETParams = function () {
	var t = location.search.substring(1).split('&');
	var f = [];
	for (var i=0; i<t.length; i++) {
		var x = t[i].split('=');
		f[x[0]]=x[1];
	}
	return f;
}
